clang 10.0.0git

Public Member Functions | Public Attributes | Friends | List of all members
clang::LiveVariables::LivenessValues Class Reference

`#include "clang/Analysis/Analyses/LiveVariables.h"`

Collaboration diagram for clang::LiveVariables::LivenessValues:
[legend]

## Public Member Functions
bool | equals (const LivenessValues &V) const
| LivenessValues ()
| LivenessValues (llvm::ImmutableSet< const Stmt *> LiveStmts, llvm::ImmutableSet< const VarDecl *> LiveDecls, llvm::ImmutableSet< const BindingDecl *> LiveBindings)
bool | isLive (const Stmt *S) const
bool | isLive (const VarDecl *D) const

## Public Attributes
llvm::ImmutableSet< const Stmt * > | liveStmts
llvm::ImmutableSet< const VarDecl * > | liveDecls
llvm::ImmutableSet< const BindingDecl * > | liveBindings

## Friends
class | LiveVariables

## Detailed Description

Definition at line 30 of file LiveVariables.h.

## Constructor & Destructor Documentation

## ◆ LivenessValues() [1/2]

clang::LiveVariables::LivenessValues::LivenessValues | ( |  | ) |
| inline

Definition at line 39 of file LiveVariables.h.

## ◆ LivenessValues() [2/2]

clang::LiveVariables::LivenessValues::LivenessValues | ( | llvm::ImmutableSet< const Stmt *> | LiveStmts,
|  | llvm::ImmutableSet< const VarDecl *> | LiveDecls,
|  | llvm::ImmutableSet< const BindingDecl *> | LiveBindings
| ) |  |
| inline

Definition at line 42 of file LiveVariables.h.

References isLive().

## Member Function Documentation

## ◆ equals()

bool LiveVariables::LivenessValues::equals | ( | const LivenessValues & | V | ) | const

Definition at line 171 of file LiveVariables.cpp.

References liveDecls, and liveStmts.

Referenced by clang::LiveVariables::computeLiveness().

## ◆ isLive() [1/2]

bool LiveVariables::LivenessValues::isLive | ( | const Stmt * | S | ) | const

Definition at line 114 of file LiveVariables.cpp.

Referenced by LivenessValues(), LookThroughTransitiveAssignmentsAndCommaOperators(), and clang::LiveVariables::Observer::observerKill().

## ◆ isLive() [2/2]

bool LiveVariables::LivenessValues::isLive | ( | const VarDecl * | D | ) | const

Definition at line 118 of file LiveVariables.cpp.

References liveBindings, liveDecls, and liveStmts.

## Friends And Related Function Documentation

## ◆ LiveVariables

friend class LiveVariables
| friend

Definition at line 51 of file LiveVariables.h.

Referenced by clang::LiveVariables::create().

## Member Data Documentation

## ◆ liveBindings

llvm::ImmutableSet<const BindingDecl *> clang::LiveVariables::LivenessValues::liveBindings

Definition at line 35 of file LiveVariables.h.

Referenced by isLive().

## ◆ liveDecls

llvm::ImmutableSet<const VarDecl *> clang::LiveVariables::LivenessValues::liveDecls

Definition at line 34 of file LiveVariables.h.

Referenced by clang::LiveVariables::dumpBlockLiveness(), equals(), isLive(), and writeShouldKill().

## ◆ liveStmts

llvm::ImmutableSet<const Stmt *> clang::LiveVariables::LivenessValues::liveStmts

Definition at line 33 of file LiveVariables.h.

Referenced by equals(), and isLive().

The documentation for this class was generated from the following files:

- include/clang/Analysis/Analyses/LiveVariables.h
- lib/Analysis/LiveVariables.cpp